# Property of Four Js*
# (c) Copyright Four Js 1995, 2012. All Rights Reserved.
# * Trademark of Four Js Development Tools Europe Ltd
#   in the United States and elsewhere
# 
# Four Js and its suppliers do not warrant or guarantee that these
# samples are accurate and suitable for your purposes. Their inclusion is
# purely for information purposes only.

DEFINE a DYNAMIC ARRAY OF RECORD
             testname STRING,
             description STRING
         END RECORD
DEFINE tc INTEGER

MAIN
  DEFINE canshow BOOLEAN

  OPEN FORM f FROM arg_val(0)
  DISPLAY FORM f

  LET tc = 0

  CALL addtest("--------","----------------------------------------------")
  CALL addtest("grid01","Fields without labels")
  CALL addtest("grid02","4 Labels and 5 fields")
  CALL addtest("grid03","5 Labels and 5 fields")
  CALL addtest("grid04","4 Labels, 5 fields and 2 buttons")
  CALL addtest("grid05","2/2/2 buttons + 1 big button")
  CALL addtest("grid06","3/2 buttons + 2 big button")
  CALL addtest("grid07","Many fields aligned 1")
  CALL addtest("grid08","Many fields aligned 2")
  CALL addtest("grid09","Long label with some fields below")
  CALL addtest("grid10","TextEdits with strech attribute")
  CALL addtest("grid51","GroupBox layout tag with some fields 1")
  CALL addtest("grid52","GroupBox layout tag with some fields 2")
  CALL addtest("grid53","GroupBox layout tag with long label above")
  CALL addtest("grid54","Two groupbox layout tags aligned vertically")
  CALL addtest("grid55","Two + one groupbox layout tags")
  CALL addtest("grid56","One GroupBox and one Table layout tag")
  CALL addtest("grid57","One GroupBox and two Tables layout tag")
  CALL addtest("grid58","Two GroupBoxes and one Table layout tag")
  CALL addtest("grid70","ScrollGrid layout tag with 3 rows")
  CALL addtest("grid71","ScrollGrid layout tag with 1 row + Group")
  CALL addtest("grid72","Two ScrollGrid layout tags")
  CALL addtest("grid73","ScrollGrid + Table layout tag")
  CALL addtest("grid80","2 GroupBox layout tags with gridChildrenInParent")
  CALL addtest("grid81","3 GroupBox layout tags with gridChildrenInParent")
  CALL addtest("grid82","Sample of grids with name")
  CALL addtest("grid83","<S Scrollgrid > with attributes in ATTRIBUTES section")
  CALL addtest("grid84","<T Table >  with attributes in ATTRIBUTES section")
  CALL addtest("grid85","Grid with HBox tags in groupboxes")
  CALL addtest("grid86","ButtonEdit in HBox tag + real width specification")
  CALL addtest("grid87","Combobox in HBox tag")
  CALL addtest("grid88","Edit in HBox tag with label on top")
  CALL addtest("grid89","Tables side by side in HBox with splitter")
  CALL addtest("grid90","Tables stacked vertically in VBox with splitter")
  CALL addtest("grid91","2 Tables and a stretchable textedit in VBox with splitter")
  CALL addtest("--------","----------------------------------------------")
  CALL addtest("folder01","Folder + 2 pages+grid")
  CALL addtest("folder02","Folder + 1 page+grid + 1 page+table")
  CALL addtest("folder03","Folder + 2 pages+(group+grid)")
  CALL addtest("folder04","Folder + 1 page+(group+grid) + 1 page+table")
  CALL addtest("folder05","Folder + 1 page+(group+grid) + 1 page+table + 1 page+(grid+textedit)")
  CALL addtest("folder06","Folder + 1 page+(vbox+(group+grid)+table) + 1 page+grid")
  CALL addtest("folder07","Folder + 1 page+(hbox+(group+grid)+table) + 1 page+grid")
  CALL addtest("folder08","Folder + 2 pgs+(fld+2(pgs+grd)) + 1 pg+fld+pg+fld+2pgs")
  CALL addtest("folder09","Folder + 3 Pages. Some are named")
  CALL addtest("--------","----------------------------------------------")
  CALL addtest("group01","Group with a grid")
  CALL addtest("group02","Group with a table")
  CALL addtest("group03","Group with vbox + grid")
  CALL addtest("group04","Group with vbox + 2 grids")
  CALL addtest("group05","Group with vbox + grid+table")
  CALL addtest("group06","Group + group + grid+table")
  CALL addtest("group07","Group + group + vbox + grid+table")
  CALL addtest("group08","Group + vbox + group+grid + group+table")
  CALL addtest("group09","Group + vbox + group+grid + table")
  CALL addtest("group10","Group + hbox + group+grid + table")
  CALL addtest("group11","Group + hbox + group+grid + group+table")
  CALL addtest("group12","Group + group + hbox + grid+table")
  CALL addtest("group13","Group with hbox + grid+table")
  CALL addtest("group14","Group with hbox + 2 grids")
  CALL addtest("group15","Group with hbox + grid")
  CALL addtest("group16","Groups with name and attribute section")
  CALL addtest("--------","----------------------------------------------")
  CALL addtest("vbox01","Vbox with 1 grid")
  CALL addtest("vbox02","Vbox with 1 table")
  CALL addtest("vbox03","Vbox with 2 grids")
  CALL addtest("vbox04","Vbox with 2 tables")
  CALL addtest("vbox05","Vbox with 1 grid + 1 table")
  CALL addtest("vbox06","Vbox with 1 group + 1 grid")
  CALL addtest("vbox07","Vbox with 1 group+grid + 1 group+table")
  CALL addtest("vbox08","Vbox with 2 group+grid")
  CALL addtest("vbox09","Vbox with 2 group+table")
  CALL addtest("vbox10","Vbox with 2 group+grid and 1 group+table")
  CALL addtest("vbox11","Vbox with 2 group+table and 1 group+grid")
  CALL addtest("vbox12","Vbox with 2 group+table and 1 group+grid - all same width")
  CALL addtest("vbox13","Vbox with 2 HBox+2(group+grid)")
  CALL addtest("vbox14","Vbox with 2 Groups + (HBox+2(group+grid))")
  CALL addtest("vbox15","Named VBox")
  CALL addtest("--------","----------------------------------------------")
  CALL addtest("hbox01","Hbox with 1 grid")
  CALL addtest("hbox02","Hbox with 1 table")
  CALL addtest("hbox03","Hbox with 2 grids")
  CALL addtest("hbox04","Hbox with 2 tables")
  CALL addtest("hbox05","Hbox with 1 grid + 1 table")
  CALL addtest("hbox06","Hbox with 1 group + 1 grid")
  CALL addtest("hbox07","Hbox with 1 group+grid + 1 group+table")
  CALL addtest("hbox08","Hbox with 2 group+grid")
  CALL addtest("hbox09","Hbox with 2 group+table")
  CALL addtest("hbox10","Hbox with 2 group+grid and 1 group+table")
  CALL addtest("hbox11","Hbox with 2 group+table and 1 group+grid")
  CALL addtest("hbox12","Hbox with 3 groups+grid - all same height")
  CALL addtest("hbox13","Hbox with 2 VBox+2(group+grid)")
  CALL addtest("hbox14","Hbox with 2 Groups + (VBox+2(group+grid))")
  CALL addtest("hbox15","Named HBox")
  CALL addtest("--------","----------------------------------------------")
  CALL addtest("scrollgrid01","ScrollGrid with 3 rows")
  CALL addtest("scrollgrid02","ScrollGrid with 1 row")
  CALL addtest("scrollgrid03","VBox + 2 ScrollGrids")
  CALL addtest("scrollgrid04","VBox + ScrollGrid + Table")

  CALL addtest("scrollgrid10","Group + ScrollGrid")
  CALL addtest("scrollgrid11","VBox with Group+ScrollGrid And Group+Grid")
  CALL addtest("scrollgrid12","VBox with 2 Group+ScrollGrid")
  CALL addtest("scrollgrid13","VBox with Group+ScrollGrid And Group+Table")
  CALL addtest("scrollgrid14","ScrollGrid with a name")
  CALL addtest("scrollgrid15","ScrollGrid with TEXTEDIT")

  LET int_flag=FALSE
  DISPLAY ARRAY a TO sr.* ATTRIBUTES(COUNT=tc,CANCEL=FALSE)
    BEFORE ROW
       LET canshow = a[arr_curr()].testname.subString(1,1) != '-'
       CALL DIALOG.setActionActive("showper", canshow)
       CALL DIALOG.setActionActive("show42f", canshow)
       CALL DIALOG.setActionActive("showfrm", canshow)
    ON ACTION showper
       CALL showfile(a[arr_curr()].testname||".per")
    ON ACTION show42f
       CALL showfile(a[arr_curr()].testname||".42f")
    ON ACTION showfrm
       CALL showform(a[arr_curr()].testname,a[arr_curr()].description)
    ON ACTION close
       EXIT DISPLAY
  END DISPLAY

END MAIN

FUNCTION addtest(n,d)
  DEFINE n,d STRING
  LET tc=tc+1
  LET a[tc].testname = n
  LET a[tc].description = d
END FUNCTION

FUNCTION showform(fn,wt)
  DEFINE fn,wt STRING
  OPEN WINDOW w WITH FORM fn ATTRIBUTES(TEXT=wt)
  MENU "test" COMMAND "exit" EXIT MENU END MENU
  CLOSE WINDOW w
END FUNCTION

FUNCTION showfile(fn)
  DEFINE fn STRING
  DEFINE txt STRING
  OPEN WINDOW w WITH FORM "Layout1"
     ATTRIBUTE(TEXT="File: ["||fn||"]",STYLE="dialog")
  LET txt = readfile(fn)
  INPUT BY NAME txt WITHOUT DEFAULTS
  LET int_flag=FALSE
  CLOSE WINDOW w
END FUNCTION

FUNCTION readfile(fn)
  DEFINE fn STRING
  DEFINE txt STRING
  DEFINE ln STRING
  DEFINE ch base.Channel
  LET ch=base.channel.create()
  CALL ch.openfile(fn,"r")
  WHILE ch.read(ln)
    IF txt IS NULL THEN
      IF ln IS NULL THEN
        LET txt = "\n"
      else
        LET txt = ln
      END IF
    ELSE
      IF ln IS NULL THEN
        LET txt = txt || "\n"
      ELSE
        LET txt = txt || "\n" || ln
      END IF
    END IF
  END WHILE
  CALL ch.close()
  RETURN txt
END FUNCTION

